package betterwithmods.common.blocks.mechanical;

import betterwithmods.api.block.IMultiVariants;
import betterwithmods.api.block.IOverpower;
import betterwithmods.common.BWMBlocks;
import betterwithmods.common.BWMItems;
import betterwithmods.common.BWSounds;
import betterwithmods.common.blocks.BlockRotate;
import betterwithmods.common.blocks.EnumTier;
import betterwithmods.common.blocks.mechanical.tile.TileBellows;
import betterwithmods.common.registry.BellowsManager;
import betterwithmods.util.DirUtils;
import betterwithmods.util.InvUtils;
import betterwithmods.util.WorldUtils;
import net.minecraft.block.Block;
import net.minecraft.block.SoundType;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.BlockFaceShape;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.init.Blocks;
import net.minecraft.init.SoundEvents;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.NonNullList;
import net.minecraft.util.SoundCategory;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;

import javax.annotation.Nullable;
import java.util.List;
import java.util.Optional;
import java.util.Random;

public class BlockBellows extends BlockRotate implements IBlockActive, IOverpower, IMultiVariants {

    public BlockBellows() {
        super(Material.field_151575_d);
        this.func_149675_a(true);
        this.func_149711_c(2.0F);
        this.func_180632_j(this.field_176227_L.func_177621_b().func_177226_a(DirUtils.HORIZONTAL, EnumFacing.SOUTH).func_177226_a(ACTIVE, false).func_177226_a(EnumTier.TIER, EnumTier.WOOD));
        this.func_149672_a(SoundType.field_185848_a);
    }

    @Override
    public boolean hasTileEntity(IBlockState state) {
        return true;
    }

    @Nullable
    @Override
    public TileEntity createTileEntity(World world, IBlockState state) {
        return new TileBellows();
    }

    @Override
    public int func_149738_a(World world) {
        return 37;
    }

    @Override
    public void nextState(World world, BlockPos pos, IBlockState state) {
        world.func_175656_a(pos, state.func_177231_a(DirUtils.HORIZONTAL).func_177226_a(ACTIVE, false));
    }

    @Override
    public boolean func_149662_c(IBlockState state) {
        return state.func_177230_c() == this && !state.func_177229_b(ACTIVE);
    }

    @Override
    public boolean func_149686_d(IBlockState state) {
        return state.func_177230_c() == this && !state.func_177229_b(ACTIVE);
    }

    @Deprecated
    @Override
    public IBlockState getStateForPlacement(World world, BlockPos pos, EnumFacing side, float flX, float flY, float flZ,
                                            int meta, EntityLivingBase living, EnumHand hand) {
        IBlockState state = super.getStateForPlacement(world, pos, side, flX, flY, flZ, meta, living, hand);
        return setFacingInBlock(state, living.func_174811_aO()).func_177226_a(ACTIVE, false).func_177226_a(EnumTier.TIER, EnumTier.VALUES[meta]);
    }

    @Override
    public int func_180651_a(IBlockState state) {
        return state.func_177229_b(EnumTier.TIER).ordinal();
    }

    public IBlockState setFacingInBlock(IBlockState state, EnumFacing facing) {
        return state.func_177226_a(DirUtils.HORIZONTAL, facing);
    }

    public EnumTier getTier(World world, BlockPos pos) {
        IBlockState state = world.func_180495_p(pos);
        if (state.func_177227_a().contains(EnumTier.TIER)) {
            return state.func_177229_b(EnumTier.TIER);
        }
        return null;
    }

    public EnumFacing getFacing(IBlockState state) {
        return state.func_177229_b(DirUtils.HORIZONTAL);
    }

    @Override
    public void func_180633_a(World world, BlockPos pos, IBlockState state, EntityLivingBase entity,
                                ItemStack stack) {
        if (entity == null)
            setFacingInBlock(state, EnumFacing.NORTH);
        EnumFacing facing = DirUtils.convertEntityOrientationToFlatFacing(entity);
        setFacingInBlock(state, facing);
        world.func_180497_b(pos, this, 10, 5);
    }

    @Override
    public AxisAlignedBB func_185496_a(IBlockState state, IBlockAccess world, BlockPos pos) {
        if (state.func_177229_b(ACTIVE))
            return new AxisAlignedBB(0.0F, 0.0F, 0.0F, 1.0F, 0.6875F, 1.0F);
        return field_185505_j;
    }

    @Override
    public void onChangeActive(World world, BlockPos pos, boolean active) {
        world.func_180497_b(pos, this, func_149738_a(world), 5);
        if (active) {
            world.func_184133_a(null, pos, BWSounds.BELLOW, SoundCategory.BLOCKS, 0.7F, world.field_73012_v.nextFloat() * 0.25F + 2.5F);
            blow(world, pos);
        } else {
            world.func_184133_a(null, pos, BWSounds.BELLOW, SoundCategory.BLOCKS, 0.2F, world.field_73012_v.nextFloat() * 0.25F + 2.5F);
        }
        liftCollidingEntities(world, pos);
    }

    @Override
    public void func_189540_a(IBlockState state, World world, BlockPos pos, Block block, BlockPos other) {
        withTile(world, pos).ifPresent(TileBellows::onChange);
    }

    @Override
    public void func_180650_b(World world, BlockPos pos, IBlockState state, Random rand) {
        withTile(world, pos).ifPresent(TileBellows::onChange);
    }

    @Override
    public void overpower(World world, BlockPos pos) {
        breakBellows(world, pos);
    }

    public void blow(World world, BlockPos pos) {
        stokeFlames(world, pos);
        blowItems(world, pos);
    }

    public void blowItems(World world, BlockPos pos) {
        EnumFacing facing = getFacing(world.func_180495_p(pos));
        BlockPos pos2 = pos.func_177967_a(facing, 4);
        AxisAlignedBB box = new AxisAlignedBB(pos.func_177958_n(), pos.func_177956_o(), pos.func_177952_p(), pos2.func_177958_n() + 1, pos2.func_177956_o() + 1, pos2.func_177952_p() + 1);

        List<EntityItem> items = world.func_72872_a(EntityItem.class, box);
        for (EntityItem item : items) {
            blowItem(pos, facing, item);
        }
    }

    private final float scale = 4 / 16f;

    public void blowItem(BlockPos pos, EnumFacing facing, EntityItem item) {
        double x = 0, z = 0;

        if (WorldUtils.getDistance(pos, item.func_180425_c()) > BellowsManager.getWeight(item.func_92059_d()))
            return;
        switch (facing.func_176740_k()) {
            case X:
                x += facing.func_176743_c().func_179524_a();
                break;
            case Z:
                z += facing.func_176743_c().func_179524_a();
                break;
        }

        item.func_70024_g(x * scale, 0, z * scale);
    }

    public void playStateChangeSound(World world, BlockPos pos) {
        liftCollidingEntities(world, pos);
    }

    private void stokeFlames(World world, BlockPos pos) {
        EnumFacing dir = getFacing(world.func_180495_p(pos));
        EnumFacing dirLeft = DirUtils.rotateFacingAroundY(getFacing(world.func_180495_p(pos)), false);
        EnumFacing dirRight = DirUtils.rotateFacingAroundY(getFacing(world.func_180495_p(pos)), true);

        for (int i = 0; i < 3; i++) {
            BlockPos dirPos = pos.func_177967_a(dir, 1 + i);
            //
            Block target = world.func_180495_p(dirPos).func_177230_c();

            if (target == Blocks.field_150480_ab || target == BWMBlocks.STOKED_FLAME)
                stokeFire(world, dirPos);
            else if (!world.func_175623_d(dirPos))
                break;
            //
            BlockPos posLeft = dirPos.func_177972_a(dirLeft);

            Block targetLeft = world.func_180495_p(posLeft).func_177230_c();
            if (targetLeft == Blocks.field_150480_ab || targetLeft == BWMBlocks.STOKED_FLAME)
                stokeFire(world, posLeft);
            //
            BlockPos posRight = dirPos.func_177972_a(dirRight);

            Block targetRight = world.func_180495_p(posRight).func_177230_c();
            if (targetRight == Blocks.field_150480_ab || targetRight == BWMBlocks.STOKED_FLAME)
                stokeFire(world, posRight);
        }
    }

    private void stokeFire(World world, BlockPos pos) {
        BlockPos down = pos.func_177977_b();
        if (world.func_180495_p(down).func_177230_c() == BWMBlocks.HIBACHI) {
            int flag = (world.func_180495_p(pos).func_177230_c() == BWMBlocks.STOKED_FLAME) ? 4 : 3;
            world.func_180501_a(pos, BWMBlocks.STOKED_FLAME.func_176223_P(), flag);
        } else
            world.func_175698_g(pos);
    }

    private void liftCollidingEntities(World world, BlockPos pos) {
        int x = pos.func_177958_n();
        int y = pos.func_177956_o();
        int z = pos.func_177952_p();
        List<Entity> list = world.func_72872_a(Entity.class,
                new AxisAlignedBB(x, y + 0.6875F, z, x + 1, y + 1, z + 1));

        float extendedY = y + 1;

        if (list != null && list.size() > 0) {
            for (Entity entity : list) {
                if (!entity.field_70128_L && (entity.func_70104_M() || entity instanceof EntityItem)) {
                    double tempY = entity.func_174813_aQ().field_72338_b;

                    if (tempY < extendedY) {
                        double entityOffset = extendedY - tempY;
                        entity.func_70107_b(entity.field_70165_t, entity.field_70163_u + entityOffset, entity.field_70161_v);
                    }
                }
            }
        }
    }

    public void breakBellows(World world, BlockPos pos) {
        InvUtils.ejectStackWithOffset(world, pos, new ItemStack(Blocks.field_150376_bx, 2, 0));
        InvUtils.ejectStackWithOffset(world, pos, new ItemStack(BWMItems.MATERIAL, 1, 0));
        InvUtils.ejectStackWithOffset(world, pos, new ItemStack(BWMItems.MATERIAL, 2, 6));
        world.func_184133_a(null, pos, SoundEvents.field_187539_bB, SoundCategory.BLOCKS, 0.3F,
                world.field_73012_v.nextFloat() * 0.1F + 0.45F);
        world.func_175698_g(pos);
    }

    @Override
    public int func_176201_c(IBlockState state) {
        int facing = state.func_177229_b(DirUtils.HORIZONTAL).func_176736_b();
        int tier = state.func_177229_b(EnumTier.TIER).ordinal();
        int active = isActive(state) ? 1 : 0;
        return active | tier << 1 | facing << 2;
    }

    @Override
    public IBlockState func_176203_a(int meta) {
        return this.func_176223_P().func_177226_a(ACTIVE, (meta & 1) == 1).func_177226_a(EnumTier.TIER, EnumTier.VALUES[(meta >> 1 & 1)]).func_177226_a(DirUtils.HORIZONTAL, EnumFacing.func_176731_b(meta >> 2));
    }

    @Override
    public BlockStateContainer func_180661_e() {
        return new BlockStateContainer(this, DirUtils.HORIZONTAL, ACTIVE, EnumTier.TIER);
    }

    public Optional<TileBellows> withTile(World world, BlockPos pos) {
        return Optional.ofNullable(getTile(world, pos));
    }

    public TileBellows getTile(World world, BlockPos pos) {
        TileEntity tile = world.func_175625_s(pos);
        if (tile instanceof TileBellows)
            return (TileBellows) tile;
        return null;
    }

    @Override
    public void func_149666_a(CreativeTabs itemIn, NonNullList<ItemStack> items) {
        items.add(new ItemStack(this, 1, 0));
        items.add(new ItemStack(this, 1, 1));
    }

    @Override
    public String[] getVariants() {
        return new String[]{"active=true,facing=north,tier=wood", "active=true,facing=north,tier=steel"};
    }

    @Override
    public BlockFaceShape func_193383_a(IBlockAccess worldIn, IBlockState state, BlockPos pos, EnumFacing face) {
        return face != EnumFacing.DOWN && state.func_177229_b(ACTIVE) ? BlockFaceShape.UNDEFINED : BlockFaceShape.SOLID;
    }
}
