package betterwithmods.manual.client.manual.provider;

import betterwithmods.BWMod;
import betterwithmods.common.BWMBlocks;
import betterwithmods.common.blocks.*;
import betterwithmods.common.blocks.mechanical.BlockCookingPot;
import betterwithmods.common.blocks.mechanical.BlockMechMachines;
import betterwithmods.common.blocks.mechanical.BlockWindmill;
import betterwithmods.common.blocks.mini.BlockMini;
import betterwithmods.manual.api.manual.PathProvider;
import com.google.common.collect.Sets;
import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.item.ItemStack;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

import javax.annotation.Nullable;
import java.util.Set;

import static net.minecraft.block.material.Material.ROCK;
import static net.minecraft.block.material.Material.WOOD;

/**
 * Created by primetoxinz on 6/18/17.
 */
public class DefinitionPathProvider implements PathProvider {
    public static Set<ItemStack> blacklist = Sets.newHashSet(ItemStack.field_190927_a);

    public static boolean isBlacklisted(ItemStack stack) {
        return blacklist.stream().anyMatch(stack::func_77969_a);
    }

    @Nullable
    @Override
    public String pathFor(ItemStack stack) {
        if (isBlacklisted(stack) || !stack.func_77973_b().getRegistryName().func_110624_b().equals(BWMod.MODID))
            return null;
        String path = stack.func_77977_a().replace("item.bwm:", "");
        return "%LANGUAGE/items/" + path;
    }

    @Nullable
    @Override
    public String pathFor(World world, BlockPos pos) {
        IBlockState state = world.func_180495_p(pos);
        Block block = state.func_177230_c();

        int meta = block.func_180651_a(state);

        if (block instanceof BlockKiln)
            return "%LANGUAGE%/blocks/kiln";

        ItemStack stack = new ItemStack(block, 1, meta);

        if (isBlacklisted(stack) || !stack.func_77973_b().getRegistryName().func_110624_b().equals(BWMod.MODID))
            return null;
        else if (block instanceof BlockRope)
            return "%LANGUAGE%/items/rope";
        else if (block == BWMBlocks.PLANTER)
            return "%LANGUAGE%/blocks/planter";
        else if (block == BWMBlocks.BLOOD_SAPLING || block == BWMBlocks.BLOOD_LOG || block == BWMBlocks.BLOOD_LEAVES) {
            return "%LANGUAGE%/blocks/blood_wood";
        } else if (block instanceof BlockChime) {
            return "%LANGUAGE%/blocks/wind_chime";
        } else if (block instanceof BlockCookingPot) {
            return "%LANGUAGE%/blocks/" + state.func_177229_b(BlockCookingPot.TYPE).func_176610_l();
        } else if (block instanceof BlockMechMachines) {
            return "%LANGUAGE%/blocks/" + state.func_177229_b(BlockMechMachines.TYPE).func_176610_l();
        } else if (block instanceof BlockFurniture || block instanceof BlockPane || block instanceof BlockIronWall) {
            return "%LANGUAGE%/blocks/decoration";
        } else if (block instanceof BlockMini) {
            Material mat = state.func_185904_a();
            if (mat == field_151575_d || mat == BlockMini.MINI) {
                return "%LANGUAGE%/blocks/minimized_wood";
            } else if (mat == field_151576_e) {
                return "%LANGUAGE%/blocks/minimized_stone";
            }
        } else if (block instanceof BlockEnderchest || state.equals(BlockAesthetic.getVariant(BlockAesthetic.EnumType.ENDERBLOCK))) {
            return "%LANGUAGE%/hardcore/beacons";
        } else if (block instanceof BlockWindmill) {
            return "%LANGUAGE%/blocks/windmill";
        }

        String path = stack.func_77977_a().replace("tile.bwm:", "");
        return "%LANGUAGE%/blocks/" + path;
    }
}
